import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { TreeViewComponent } from '@syncfusion/ej2-angular-navigations';

import { AppRoutingModule } from './app-routing.module';
import {HttpClientModule} from '@angular/common/http';
import { AppComponent } from './app.component';
import { DataFetchComponent } from './data-fetch/data-fetch.component';
import { UrldataService } from './urldata.service';
import { HomeviewComponent } from './homeview/homeview.component';

@NgModule({
  declarations: [
    AppComponent,
    DataFetchComponent,
    TreeViewComponent,
    HomeviewComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    HttpClientModule
  ],
  providers: [UrldataService],
  bootstrap: [AppComponent]
})
export class AppModule { }
