import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http'; 
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';

@Injectable()
export class UrldataService {
  
  constructor(private http: HttpClient) {
        // this.getJSON().subscribe(data => {
        //     console.log(data);
        // });
    }

    // public getJSON(): Observable<any> {
    //     console.log(this.http.get("./assets/mydata.json"));
    // }
    public dataTable() {
      return this.http.get("http://localhost/Data/mydata.json");
    }
    getData()
    { 
        return this.http.get('http://localhost/Data/mydata.json').map(data=>{
            return this.process(data);
        }).catch(
            (error: Response) => {
              return Observable.throw(error);
            });
    }
    process(data:any)  
    {
        let dataTransform:any[]=[];
        let onlyHostArray=[];
        let onlyPaths=[];
        let k:number=0;
        let mainID:number=1;
        let pathID:number=1;
        let dupID:number=1;
        let currentPathID:number;        
        let CurrentHostID:number;
        let xtradata:any[]=[];
        let hostFlag:boolean=false;
        let hostFinalID:number;
        let pathName:string; 

        for (let item of data)
        {
          // console.log(item.name); 
            if(dataTransform.length > 0) {
              dupID=mainID-1;
              pathID=hostFinalID;
              //====For Host level filtering=====//
              if(onlyHostArray.includes(item.host)) {
                //=======For Path/Folders========//               
                for(let i=0;i<item.path.length;i++) {    
                  if(onlyPaths.length > 0) {                   
                    pathName=item.path[i];                    
                    if(onlyPaths.includes(item.path[i])) {
                      localStorage.setItem("pathnextname",item.path[i+1]);
                      if(onlyPaths.includes(item.path[i+1])) {
                      } else {                        
                          let pathNamestoredSession:string = localStorage.getItem("pathnextname");
                          var idx = dataTransform.length - 1 - dataTransform.slice().reverse().findIndex( (o) => o.name == item.path[i]);                                               
                          const value = dataTransform[idx].id;
                          if(pathNamestoredSession!=="undefined") {  
                            onlyPaths.push(pathNamestoredSession);
                            dataTransform.push({"id":mainID,"pid": value,"name":pathNamestoredSession,hasChild: true, expanded: true,"data":"folder"});
                          }
                      }                      
                    }  
                    else {
                      onlyPaths.push(item.path[i]);
                      if(i>0){
                        currentPathID=mainID-1;
                        hostFlag=false;
                      } else if(i==0) {
                        currentPathID=pathID;
                        hostFlag=false;
                      }                       
                      //=======Search which Host currently===========//
                      if(hostFlag == true){
                        currentPathID=hostFinalID;
                        hostFlag=false;
                      }                    
                      dataTransform.push({"id":mainID,"pid": currentPathID,"name":item.path[i],hasChild: true, expanded: true,"data":"folder"});                                          
                    }   
                  } else {
                    onlyPaths.push(item.path[i]);
                    // console.log('dupID',dupID);
                    dataTransform.push({"id":mainID,"pid": dupID,"name":item.path[i],hasChild: true, expanded: true,"data":"folder"});
                  }    
                  
                  //=======For Url name & monitors=============//
                  if(i==(item.path.length-1)) {       //Which means I am currently on last folder
                    let urlName_MonitorName = "("+item.class+")"+item.name;
                    var monitorparentID = dataTransform.length - 1 - dataTransform.slice().reverse().findIndex( (o) => o.name == item.path[i]);                                               
                    const MonitorIDvalue = dataTransform[monitorparentID].id;
                    dataTransform.push({"id":mainID+1,"pid": MonitorIDvalue,"name":urlName_MonitorName,isChecked: false,"data":item}); 
                  }
                  //=======For Url name & monitors=============//
                  pathID++;
                  mainID++;
                }    
              }
              else {
                onlyPaths = [];
                onlyHostArray.push(item.host);
                hostFlag=true;
                hostFinalID=mainID;
                dataTransform.push({"id":mainID,"name":item.host,hasChild: true, expanded: true,"data":"host"});
                // console.log('else---',dataTransform);
              }
            //====When array is blank=====//
            } else {
              onlyPaths = [];
              onlyHostArray.push(item.host);
              hostFlag=true;
              hostFinalID=mainID;
              dataTransform.push({"id":mainID,"name":item.host,hasChild: true, expanded: true,"data":"host"});
            }
            k++;
            mainID++;
        }
        return dataTransform;
    }
    // process(data:any) {
    //   let dataTransform:any[]=[];
    //   let onlyPaths=[];
    //   let onlyHostArray=[];
    //   let folderPathID:number;
    //   let mainID:number=1;
    //   let MonitorID:number;
    //   for (let item of data) {
    // //===========Host=======================//            
    //     dataTransform.push({"id":mainID,"name":item.host,hasChild: true, expanded: true});
    //     folderPathID=mainID;        //Keeping track of previous ID for getting parent ID
    //     mainID++;
    //     //=================For Path/Folders===================//
    //     for(let i=0;i<item.path.length;i++) {
    //       dataTransform.push({"id":mainID,"pid": folderPathID,"name":item.path[i],hasChild: true, expanded: true});
    //       MonitorID=mainID;
    //       mainID++;
    //       if(i==item.path.length-1) {
    //         let urlName_MonitorName = "("+item.class+")"+item.name;
    //         dataTransform.push({"id":mainID,"pid": MonitorID,"name":urlName_MonitorName,isChecked: false}); 
    //       }
    //     }        
    //   }
    //   return dataTransform;
    // }
}
