import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { AppComponent } from './app.component';
import { DataFetchComponent } from './data-fetch/data-fetch.component';


const routes: Routes = [
  // { path: '', redirectTo: '/app-root', pathMatch: 'full' },
  // { path: 'app-root', component: AppComponent },
  // { path: 'home', component: HomeComponent },
  { path: '',redirectTo: "/data",pathMatch: 'full' },
  { path: 'home', component: AppComponent},
  { path: 'data', component: DataFetchComponent }
  ];
  

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule { }
