import { Component, OnInit, ViewChild } from '@angular/core';
import {HttpClient } from '@angular/common/http';
import { TreeViewComponent } from '@syncfusion/ej2-angular-navigations';
import 'rxjs/add/observable/timer';


import { Observable,Subscription } from 'rxjs';
import { HttpErrorResponse } from '@angular/common/http';
import { UrldataService } from '../urldata.service';




@Component({
  selector: 'app-data-fetch',
  templateUrl: './data-fetch.component.html',
  styleUrls: ['./data-fetch.component.css']
})
export class DataFetchComponent implements OnInit {
  myData:Object[];
  showSelection:any=[];
  showData:any=[];
  public field: Object;
  public dataSelection: any;
  public toTransfer: any[]=[];
  fie=[];
  subscription:Subscription;  
  allData:any=[];
  public parentID:number;
  public firstLoop:boolean=true;
  public showloader: boolean = false;      
  public showText = false;
  public errorResponseFromServer:string;
  private subscriptionA: Subscription;
  private timer: Observable<any>;
  constructor (private httpService: HttpClient,private Urldataservice:UrldataService) {   }

  ngOnInit() {
    this.fetchEvent();
    this.setTimer();
    //this.dataSelection = { dataSource: [], id: 'id', parentID: 'parentID', text: 'text', hasChildren: 'hasChildren',data:'data' };
  }
  public setTimer(){

    // set showloader to true to show loading div on view
    this.showloader   = true;

    this.timer        = Observable.timer(30000); // 5000 millisecond means 5 seconds
    this.subscriptionA = this.timer.subscribe(() => {
        // set showloader to false to hide loading div from view after 5 seconds
        this.showloader = false;
    });
  }
  fetchEvent(){
      this.subscription = this.Urldataservice.getData().subscribe((res:any) => {    
      this.myData = res          
      // this.showloader = false;
      return this.fetch(this.myData);
      },
      (errorResponse: HttpErrorResponse) => {
        console.log('error');
        this.showloader = false;
        this.errorResponseFromServer = 'Network Error occured';
        this.showText = true;
      });
 }
 fetch(data:any){
   this.field = { dataSource: this.myData, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild',data:'data' };
 }
 //@ViewChild ('tree') treevalidate: TreeViewComponent;
  // public tree: TreeViewComponent;
  public showCheckBox:boolean = true;
  public FinalImportArray:any=[];
  public displayArray:any=[];
  public dataUncheckArray:any=[];
  public newUncheckArray:any=[];
  
public nodeChecked(args): void{
      if(args.action=="check") {
        // this.displayArray = [];
        console.log('nodechecked==',args);        
        let dataGiven = args.data.length;
        this.showData = args.data.sort(function(a, b){
            return a.id-b.id
        });
        for(let k=0;k<this.showData.length;k++){
          this.showSelection.push(this.showData[k].text);
          if(this.showData[k]["parentID"]===null){
            this.showData[k].hasChildren = true;
        }     
      }
        this.dataSelection = { dataSource: this.showData, id: 'id', parentID: 'parentID', text: 'text', hasChildren: 'expanded',data:'data' };
       
        console.log('this.dataSelection===',this.dataSelection.dataSource);
        this.showData = [];   
        for(var i=0;i<dataGiven;i++){          
          //this.showSelection.push(args.data[i].text);
          if(args.data[i].text.includes('(URLMonitor)')|| args.data[i].text.includes('(PingMonitor)') || args.data[i].text.includes('(PortMonitor)')) {
            for(let k=0;k<this.field['dataSource'].length;k++) {
              if(args.data[i].text==this.field['dataSource'][k].name){
                this.toTransfer[args.data[i].text]=this.field['dataSource'][k].data;
              }
            }
          }
        }
        // this.showSelection = this.showSelection.join("/");
        this.displayArray.push(this.showSelection.join("/"));
        this.showSelection = [];
        // this.showSelection = this.showSelection.filter( function( item, index, inputArray ) {
        //    return inputArray.indexOf(item) == index;
        // });
        // console.log('checked=======',this.displayArray);        
      } else {
        // console.log('uncheck',args);
        if(args.action=="uncheck"){
          this.dataUncheckArray = [];
          let dataGiven = args.data.length;          
          for(let i=0;i<dataGiven;i++){
            this.dataUncheckArray = args.data.sort(function(a, b){
              return a.id-b.id
            });
            // this.dataUncheckArray.push(args.data[i].text)
            if(this.showSelection.includes(args.data[i].text)) {                
                // const index = this.showSelection.indexOf(args.data[i].text);
                // if (index > -1) {
                //   this.showSelection.splice(index, 1);
                // }

            }
            // this.dataUncheckArray = this.dataUncheckArray.join("/");
            

            if(args.data[i].text.includes('(URLMonitor)')|| args.data[i].text.includes('(PingMonitor)') || args.data[i].text.includes('(PortMonitor)')) {
              delete this.toTransfer[args.data[i].text];
            }
          }   
          this.newUncheckArray = [];
          for(let n=0;n<this.dataUncheckArray.length;n++){
            this.newUncheckArray.push(this.dataUncheckArray[n].text);
          }
          let newText = this.newUncheckArray.join("/");
          for(let j=0;j<this.displayArray.length;j++){             
            if(this.displayArray[j]== newText) {
              const index = j;
              if (index > -1) {
                this.displayArray.splice(index, 1);
                // delete this.displayArray[index];
              }  
            }
          }
          // if(this.displayArray.includes(this.dataUncheckArray.join("/"))) {
          //   const index = this.displayArray.indexOf(this.dataUncheckArray.join("/"));
          //   if (index > -1) {
          //       // this.showSelection.splice(index, 1);
          //       delete this.displayArray[index];
          //   }              
          // }
        }     
      }
     
    }
    public DrawNode(args){  
      if(args.node.classList.contains('e-level-1'))
      args.node.querySelector('.e-checkbox-wrapper').style.display = "none";
    }
    //=======For unchecking data===================//
    public nodeChecking(args) { 
     
  }
  importMonitors() {    
    console.log('import Array==',this.toTransfer);
  }
   ngOnDestroy() {
     this.subscription.unsubscribe();
   }
}
